/*
* This file is part of Firestorm NIDS
* Copyright (c) 2001 Gianni Tedesco
*
*    Firestorm is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    Firestorm is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with Firestorm; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef __CAPDEV_NETLINK_PLUGIN_HEADER_INCLUDED__
#define __CAPDEV_NETLINK_PLUGIN_HEADER_INCLUDED__

#include <g_globals.h>
#include <s_globals.h>
#include <plugins.h>

#include <asm/types.h>
#include <linux/netlink.h>
#include <net/if.h>

typedef struct nlhdr {
	u_int32_t	len;
	u_int32_t	mark;
	char iface[IFNAMSIZ];
}nlhdr_t, *p_nlhdr;

typedef struct nl_temp {
	nlhdr_t		hdr __attribute__((packed));
	char		data[CAP_SNAPLEN] __attribute__((packed));
}nl_temp_t, *p_nl_temp;

typedef struct cnl_priv{
	int		fd;
	int		use_if;
	struct		sockaddr_nl nls;
	char iface[IFNAMSIZ];
	packet_t	pkt;
}cnl_priv_t, *p_cnl_priv;

#endif /* __CAPDEV_NETLINK_PLUGIN_HEADER_INCLUDED__ */
