/*
* This file is part of Firestorm NIDS
* Copyright (c) 2001 Gianni Tedesco
*
*    Firestorm is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    Firestorm is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with Firestorm; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef __PKT_IP_HEADER_INCLUDED__
#define __PKT_IP_HEADER_INCLUDED__

#define IP_RF 		0x8000	/* reserved fragment flag */
#define IP_DF 		0x4000	/* dont fragment flag */
#define IP_MF 		0x2000	/* more fragments flag */
#define IP_OFFMASK 	0x1fff	/* mask for fragmenting bits */

typedef struct fs_iphdr{
#if __BYTE_ORDER == __LITTLE_ENDIAN
	u_int8_t	ihl:4;
	u_int8_t	version:4;
#elif __BYTE_ORDER == __BIG_ENDIAN
	u_int8_t	version:4;
	u_int8_t	ihl:4;
#else
#error "Couldn't determine endianness"
#endif
	u_int8_t	tos;
	u_int16_t	tot_len;
	u_int16_t	id;
	u_int16_t	frag_off;
	u_int8_t	ttl;
	u_int8_t	protocol;
	u_int16_t	csum;
	u_int32_t	saddr;
	u_int32_t	daddr;
}fs_iphdr_t, *p_ip;

#endif /* __PKT_IP_HEADER_INCLUDED__ */
